
                        
                        
                        # 03-16-2001 BY ZONGWU CAI
                          
  # S-CODE for BOOTSTRAP TEST for MODEL (22) VS MODEL (23) in EXAMPLE 4.
  
  # THIS PROGRAM IS DOING TEST. IN THIS PROGRAM, TWO FUNCTIONS ARE DEFINED:
  # localfit(...)  FOR COMPUTING LOCAL LINEAR ESTIMATION.
  # bandwidth(...) FOR COMPUTING THE AMS-VALUES DEFINED IN (12) FOR CERTAIN 
  #                RANGE OF BANDWIDTHS.
  # NOTE: THE SAME BANDWIDTH IS USED FOR BOOTSTRAP
  
  # NOTE: YOU NEED TO MODIFY THE FUNCTIONS (DEFINED BELOW)) GIVEN IN H_0
  
  # TO RUN THIS PROGRAM, WHAT YOU NEED TO DO IS TO INPUT FOLLOWINGS:
  
  # A.   You need to set following parameters according to your case 
 ##############################################################################
 pc<-1    #(1) Set pc=1 for PC; set pc=0 for UNIX     
 if(pc==1){datafile<-"c:\\res\\far\\scode\\sunspot.dat"}else
          {datafile<-"sunspot.dat"}
          #(2) Set data file name: datafile="sunspot.dat", a data file name.
 p<-8     #(3) set p, number of lagged variables in the model
 d<-3     #(4) Set d, the varying variable, say, lagged-two variable
 Q<--1    #(5) Set Q, choice of Q in (12); set Q=-1 by default (Q=4)
 h0<-seq(4,5.25,by=0.05)  
          #(6) Set h0, a sequence of the possible values for bandwidths; 
          # set h0=-1 as default 
 trans<-1 #(7) Set trans=1, if do squared-root transformation on response.
          #Note: you need to modify the program if transformation is different
 nc<-5    #(8) Set nc, the number of coefficient functions in model (23) 
 nb<-5  #(9) Set nb, the number of bootstrap replications   
 
 # B. Type ("test4.s")    
 ############################################################################## 
 
 
  #######################################################################
  # YOU MIGHT NOT NEED TO MODIFY THE FOLLOWING CODE IF YOU DO NOT 
  #######################################################################
    
  ###########################################################################
  # READ DATA FROM DATA FILE. FOR EXAMPLE, lynx data set
  ###########################################################################
      
  data<-matrix(scan(datafile), byrow=T, ncol=1)
  n<-280                                     # use data from 1700 to 1979
  if(trans==1){data<-2*(sqrt(data+1)-1)}     # do squared-root transformation
  y<-data[(p+1):n]  
  x<-rep(0, nc*(n-p))
  dim(x)<-c(n-p,nc)
  x[,1]<-data[(p-1+1):(n-1)]                 # lagged variable
  x[,2]<-data[(p-2+1):(n-2)]                 # lagged variable
  x[,3]<-data[(p-3+1):(n-3)]                 # lagged variable
  x[,4]<-data[(p-6+1):(n-6)]                 # lagged variable
  x[,5]<-data[(p-p+1):(n-p)]                 # lagged variable                                
  u<-data[(p-d+1):(n-d)]                     # varying variable  
  z<-u                                       # grid points 
  ##########################################################################
  
    
  ##########################################################################
  # DEFINE FUNCTIONS
  ###########################################################################
  
  
  ############################################################################  
  # Define the kernel function and the coefficient functions for TAR model
  # given in (22), which are needed modifying according to the specific problem
  ############################################################################# 
  kernel<-function(x){0.75*(1-x^2)*(abs(x)<=1)} 
  a0<-function(x){1.23*(x<10.3)+0.92*(x>=10.3)}
  a1<-function(x){( 1.75-0.17*abs(x-6.6))*(x<10.3)+0.87*(x>=10.3)} 
  a2<-function(x){(-1.28+0.27*abs(x-6.6))*(x<10.3)+0.17*(x>=10.3)}
  a3<-function(x){-0.24*(x>=10.3)}
  a6<-function(x){-0.06*(x>=10.3)}
  a8<-function(x){0.20*(x<10.3)+0.04*(x>=10.3)}
  ##########################################################################
  
  ##########################################################################
  # DEFINE a FUNCTION TO COMPUTE the LOCAL LINEAR ESTIMATE
  ##########################################################################
   
  localfit<-function(y,x,h,u,z){
  # y -- response variable; x -- design matrix; u -- varying variable;
  # h -- bandwidth; z -- grid point.
  
  ngrid<-length(z)                        # number of grid points
  n<-length(y)                            # number of data points
  p<-dim(x)[2]                            # number of covariates
  ff<-rep(0,ngrid*p)
  dim(ff)<-c(ngrid,p) 
  for (k in 1:ngrid){
    dx<-(u-z[k])*x
    dx<-cbind(x,dx)      
    w0<-kernel((u-z[k])/h)/h
    s0<-t(dx)%*%(w0*dx)
    s1<-solve(s0+0.0001*diag(p*2))
    beta<-s1%*%(t(dx)%*%(w0*y))
    ff[k,]<-beta[1:p]
   }
  return(ff)
  }
  ############################################################################
  
  
  ###########################################################################
  # DEFINE BANDWIDTH SELECTOR BASED ON (12)
  ##########################################################################
   
  bandwidth<-function(y,x,u,h0,Q){
  # y - response; x - design matrix; u - varying variable; 
  # h0 - possible bandwidths; Q - value of folds
  
  n<-length(y)                          # sample size
  if(Q<=0){Q<-4}
  if(sum(h0)<=0){
  y.range<-max(y)-min(y)
  aa<-n^{-0.2}
  h0<-seq(0.4*y.range*aa,0.8*y.range*aa,by=0.05)  
                                # As default, set h0=c*n^{-0.2} with c from 0.4 to 0.8
  }
  m<-floor(0.1*n)                       # define m
  nh<-length(h0)                        # number of possible bandwidths
  ams<-rep(0,Q*nh)
  dim(ams)<-c(nh,Q)
  for(qq in 1:Q){
  n1<-n-qq*m
  y0<-y[1:n1]
  x0<-x[1:n1,]
  u0<-u[1:n1]
  z0<-u[(n1+1):(n1+m)] 
  for(j in 1:nh){
  h<-h0[j]*(n/n1)^0.2
  ff<-localfit(y0,x0,h,u0,z0)             
  yhat<-apply(x[(n1+1):(n1+m),]*ff,1,sum)
  ams[j,qq]<-mean((y[(n1+1):(n1+m)]-yhat)^2)
  }
  }
  ams<-apply(ams,1,sum)
  return(cbind(h0,ams))
  }
  ############################################################################
  
  ###########################################################################  
  # DO COMPUTATION
  ##########################################################################
 

  ############################################################################
  beta<-cbind(a1(u),a2(u),a3(u),a6(u),a8(u))           
    # it needs modifying according to the specific problem
  yhat0<-a0(u)+apply(beta*x,1,sum)   # compute yhat under H_0
     
  ams<-bandwidth(y,x,u,h0,Q)    # compute AMS for certain values of bandwidths
  h0<-ams[,1]
  ind<-order(ams[,2])[1]        # locate the index of optimal bandwidth
  h.opt<-h0[ind]                # find the optimal bandwidth minimizing AMS
  
  print("I AM DONE THE OPTIMAL BANDWIDTH SEARCH")
  print(c("THE OPTIMAL BANDWIDTH IS", h.opt))
  
  beta<-localfit(y,x,h.opt,u,z)
  yhat1<-apply(beta*x,1,sum)        # compute yhat under H_1
  epsilon0<-y-yhat1                 # compute the nonparametric residuals
  epsilon0<-epsilon0-mean(epsilon0) # centerized
  rss0<-mean((y-yhat0)^2)           # compute RSS under H_0
  rss1<-mean((y-yhat1)^2)           # compute RSS under H_1
  rss1<-2.932
  tn<-(rss0-rss1)/rss1              # compute the statistic T_n
  print(c("THE OBSERVED VALUE of RSS0 is", rss0))
  print(c("THE OBSERVED VALUE of RSS1 is", rss1))
  print(c("THE OBSERVED VALUE of T_n is", tn))
  ############################################################################
  
  ############################################################################
   print(c("NOW, I BEGIN DOING BOOTSTRAP"))
   p.value<-0
   tnstar<-rep(0,nb)
   for(b in 1:nb){
   epsilon.star<-sample(epsilon0, rep=T)  # draw Bootstrap sample
   ystar<-yhat0+epsilon.star              # compute Y_i^*
   rss0<-mean((epsilon.star)^2)           # Compute RSS_0^*
   beta<-localfit(ystar,x,h.opt,u,z)
   yhat1<-apply(beta*x,1,sum)
   rss1<-mean((ystar-yhat1)^2)            # compute RSS_1^*
   tn.star<-(rss0-rss1)/rss1              # compute T_n^*
   tnstar[b]<-tn.star 
   if(pc==1){write(t(tnstar),"c:\\temp\\tnstar.out",ncol=1)}else
   {write(t(tnstar),"tnstar.out",ncol=1)}
   if(tn.star>=tn){p.value<-p.value+1}
   print(c(b, "p-value", round(p.value/b, digits=3)))
   }                                      # the end of the BOOTSTRAP loop
   p.value<-p.value/nb
   print(c("THE P-VALUE IS", p.value))
   
   print(c("I AM DONE"))
   
   ##########################################################################  
